/* $Id: initterm-r0drv.h 1  vboxsync $ */
/** @file
 * InnoTek Portable Runtime - Initialization & Termination, R0 Driver, Common.
 */

/*
 * Copyright (C) 2006 InnoTek Systemberatung GmbH
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation,
 * in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
 * distribution. VirtualBox OSE is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY of any kind.
 *
 * If you received this file as part of a commercial VirtualBox
 * distribution, then only the terms of your commercial VirtualBox
 * license agreement apply instead of the previous paragraph.
 */

#ifndef __r0drv_initterm_r0drv_h_
#define __r0drv_initterm_r0drv_h_

#include <sys/cdefs.h>

__BEGIN_DECLS

/**
 * Platform specific initialization.
 *
 * @returns IPRT status code.
 */
int rtR0InitNative(void);

/**
 * Platform specific terminiation.
 */
void rtR0TermNative(void);

__END_DECLS

#endif

